chiark / gitweb /
dot/bash*: Reformat.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
8ba15f37 13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 132 emacs emacs-calc vm gnus.el ercrc.el
b0d8acbe 133 vimrc mg zile
30169591 134 ditz-config
b3468c3b 135 mailrc signature
ce178f96 136 cgrc tigrc
e7d23024 137 gdbinit
8a7e906d 138 guile
1d89ce86 139 rcrc
5d25e440 140 toprc
a6a6806a 141 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
cbffcf2b 142 aspell.conf
ccaac00b
MW
143 lisp-init.lisp:.cmucl-init.lisp
144 lisp-init.lisp:.sbclrc
145 lisp-init.lisp:.clisprc.lisp
f6335a0c 146 lisp-init.lisp:.eclrc
b5bf3445 147 swank.lisp
2425eca9 148 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 149[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 150 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 151 fonts.conf
e517857c 152 stalonetrayrc
1c6b19d4 153 putty-defaults:.putty/sessions/Default%20Settings
7cfa1f1a 154 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 155 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 156 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 157 e16-bindings:.e16/bindings.cfg"
f617db13
MW
158echo "Installing dotfiles..."
159for d in $dotfiles; do
739bccbf
MW
160 target=.$d
161 case $d in
162 *:*) target=${d#*:} d=${d%%:*};;
163 esac
164 ft=$HOME$sub/$target
165 dir=${ft%/*}
166 mkdir -p $dir
99063107 167 ln -s $here/dot/$d $ft.new
739bccbf
MW
168 mv $ft.new $ft
169 echo " $target"
f617db13 170done
852cd5fb 171echo " all done."
f617db13 172
403dc178
MW
173## Substitute things which need substituting.
174dotfilessubst="
175 gitconfig
176 pulse-default.pa.in:.pulse/default.pa"
177echo "Installing dotfiles with substitutions..."
178for d in $dotfilessubst; do
179 case $d in
180 *:*) target=${d#*:} d=${d%%:*};;
181 *) target=.$d d=$d.in;;
182 esac
183 ft=$HOME$sub/$target
184 dir=${ft%/*}
185 mkdir -p $dir
186 sed "
1871i\
188### generated by $here/setup; do not edit!\
189
190/@home@/ s\a\a$HOME\ag
191/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
192/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
193" dot/$d >$ft.new
194 mv $ft.new $ft
195 echo " $target"
196done
197echo " all done."
198
f4e43257 199## Symlink backgrounds.
960af1a5
MW
200backgrounds="
201 jue-peek.jpg
202 medusa.jpg
5236501e 203 bsg-supper.jpg
960af1a5 204 rayne.jpg
56c871ef 205 hypatia.jpg
e1ca556b
MW
206 noodly.jpg
207 lovelace.jpg"
f4e43257
MW
208if [ "$xstuff" ]; then
209 echo "Installing backgrounds..."
210 for b in $backgrounds; do
211 for e in enlightenment e16; do
212 dir=$HOME$sub/.$e/backgrounds
213 t=$dir/$b
214 mkdir -p $dir
99063107 215 ln -s $here/bg/$b $t.new
f4e43257
MW
216 mv $t.new $t
217 done
218 echo " $b"
219 done
220 echo " all done."
221fi
222
ce178f96
MW
223###--------------------------------------------------------------------------
224### Install useful scripts included in this package.
225
e04c4857 226scripts="
547fb8af 227 mdw-editor
b20bfd83 228 mdw-pager
b056f5c4 229 mdw-conf
7ee12623 230 mdw-build
c4e84cb1 231 emacsclient-hack
8e08f814 232 movemail-hack
68b2e9e6 233 aspell-hack
285a1386
MW
234 emerge-hack
235 lesspipe.sh
236 start-ssh-agent
4cdeb0d0
MW
237 svnwrap
238 hyperspec"
8e08f814 239[ "$xstuff" ] && scripts="$scripts
3bdada49 240 xinitcmd
34a5ea4e 241 un-backslashify-selection
c02999e8 242 lock-screen
8e08f814 243 xshutdown"
e04c4857
MW
244echo "Installing scripts..."
245mkdir -p $HOME$sub/bin
246for s in $scripts; do
247 ft=$HOME$sub/bin/$s
99063107 248 ln -s $here/bin/$s $ft.new
e04c4857
MW
249 mv $ft.new $ft
250 echo " $s"
251done
252echo " all done."
253
4d7d040b
MW
254hacks="
255 ssh:ssh"
256echo "Installing hacks..."
257for h in $hacks; do
258 d=${h%%:*} h=${h#*:}
259 ft=$HOME$sub/bin/hacks/$d
260 mkdir -p $ft
261 ln -s $here/hacks/$h $ft/$h.new
262 mv $ft/$h.new $ft/$h
263 echo " $d:$h"
264done
265echo " all done."
266
ce178f96
MW
267###--------------------------------------------------------------------------
268### Set up the Emacs config.
269
65ff0e8c
MW
270$echon "Finding a suitable emacs:$echoc"
271emacs=no
5fe24792 272for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
273 if type -p >/dev/null $i; then
274 emacs=$i
275 break
276 fi
277done
278if [ $emacs = no ]; then
279 echo " failed."
280 emacs=:
281else
282 echo " $emacs."
283fi
284
f617db13 285echo "Installing Emacs packages..."
400223a1
MW
286emacspkg="
287 make-regexp
a1293ade 288 ew-hols
a3bdb4d9 289 mdw-gnus-patch
1778b496 290 git git-blame vc-git stgit
400223a1
MW
291 quilt"
292for elib in $emacspkg; do
f617db13 293 $echon " $elib:$echoc"
65ff0e8c 294 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 295 (progn
852cd5fb
MW
296 (setq load-path (nconc load-path (list "~/lib/emacs")))
297 (kill-emacs (condition-case nil
298 (progn (load-library "'"$elib"'") 0)
20eb0692 299 (error 1))))'; then
f617db13
MW
300 echo " already installed."
301 else
99063107
MW
302 if [ -f el/$elib.el ]; then
303 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
304 else
305 $echon " downloading$echoc"
306 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
307 fi
f617db13
MW
308 $echon " compiling$echoc"
309 (cd $HOME$sub/lib/emacs;
65ff0e8c 310 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 311 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
312 echo " done."
313 fi
314done
852cd5fb 315echo " all done."
f617db13
MW
316
317$echon "Setting up Emacs configuration:$echoc"
318$echon " linking$echoc"
99063107 319for f in dot-emacs.el Makefile; do
f617db13 320 set -- $(echo $link | tr : ' ')
99063107
MW
321 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
322 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
323done
324$echon " compiling$echoc"
65ff0e8c 325make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 326echo " done."
ce178f96
MW
327
328###----- That's all, folks --------------------------------------------------